config/routes.rb
Rails.application.routes.draw do

  root 'cafes#index'
  get 'dishes' => 'dishes#index'
  get 'cafes/:id' => 'cafes#show', as: 'cafes_show'
  get 'dishes/:id' => 'dishes#show', as: 'dishes_show'
  
  ActiveAdmin.routes(self)
  devise_for :users
end

app/models/adapters/only_admins.rb
class Adapters::OnlyAdmins < ActiveAdmin::AuthorizationAdapter
    def authorized?(action, subject = nil)
      user.is_admin?
    end
  end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cafe.rb
class Cafe < ApplicationRecord
	has_one_attached :image
	# validates :image,  file_content_type: { allow: ['image/jpeg', 'image/gif', 'image/png'] }

	has_many :dishes
end

app/models/dish.rb
class Dish < ApplicationRecord
	has_one_attached :image
	belongs_to :cafe
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
    validates :name, presence: true, length: { maximum: 50 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :configure_permitted_parameters, if: :devise_controller?
    
    def access_denied(exception)
        flash[:danger] = exception.message
        redirect_to root_url
      end
            
  private
  
  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name])
    devise_parameter_sanitizer.permit(:account_update, keys: [:name])
  end
end

app/controllers/cafes_controller.rb
class CafesController < ApplicationController

    def index
      @cafes = Cafe.all
    end
  
    def show
      @cafe = Cafe.find(params[:id])
    end
  end
  

app/controllers/dishes_controller.rb
class DishesController < ApplicationController

    def index
      @dishes = Dish.all
    end
  
    def show
      @dish = Dish.find(params[:id])
    end
  end

app/controllers/users_controller.rb
class UsersController < ApplicationController
    def show
      @user = User.find(params[:id])
    end
  end
  

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/cafes/_card.html.erb
<div class="card mb-4" style="min-height: 200px;">
  <%= image_tag cafe.image, size: '200', class: 'card-img-top' %>
  <div class="card-body">
  <h4 class="card-title" >
  	<%= link_to cafe.title, cafes_show_path(cafe.id) %>
  </h4>
  <div class="card-text">
  	<div>
     <p style="max-height: 100px; overflow-y: hidden;"><%= cafe.desc %></p>
		</div>
  </div>
</div>
</div>	

app/views/cafes/index.html.erb
<div class="row row-eq-height">
<% @cafes.each do |cafe| %>
	<div class="col-3">
	 <%= render partial: "cafes/card", locals: { cafe: cafe} %>
	 </div>	
<% end %>
</div>


	

app/views/cafes/show.html.erb
<div>
	<div><%= image_tag @cafe.image, size: '300' %></div>
		<h3><%= @cafe.title %></h3>
		<p><%= @cafe.desc %></p>
		<h4>Блюда:</h4>
		<div class="row">
			<% @cafe.dishes.each do |dish| %>
				<div class="col-2">
					<%= render partial: "dishes/card", locals: { dish: dish, size: 100 } %>
				</div>
			<% end %>
		</div>
	<div>      
</div>

app/views/dishes/_card.html.erb
<div class="card mb-4" style="min-height: 100px;">
  <%= image_tag dish.image, size: size, class: 'card-img-top' %>
  <div class="card-body">
  <h4 class="card-title" >
  	<%= link_to dish.title, dishes_show_path(dish.id) %>
  </h4>
  <div class="card-text">
  	<div>
     <p style="max-height: 100px; overflow-y: hidden;"><%= dish.desc %></p>
		</div>
  </div>
</div>
</div>	

app/views/dishes/index.html.erb
<div class="row">
  <% @dishes.each do |dish| %>
   <div class="col-3">
	  <%= render partial: "dishes/card", locals: { dish: dish, size: 200 } %>
   </div>
  <% end %>
</div>

app/views/dishes/show.html.erb
<div><%= image_tag @dish.image, size: '300' %></div>
<h2><%= @dish.title %></h2>
<p>Цена: <%= @dish.price %></p>
<p>Описание: <%= @dish.desc %></p>
<p>Заведение:  <%= link_to @dish.cafe.title, cafes_show_path(@dish.cafe_id) %></p>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>OrderFood</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
      <%= render 'layouts/application/navbar' %>
    <div class="container content">
      <%= yield %>
    </div>
  </body>
</html>

app/views/layouts/application/_navbar.html.erb
<nav class="navbar fixed-top navbar-dark bg-dark navbar-expand-md">
    <div class="container">
        <button type="button" class="navbar-toggler collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
          <span class="sr-only">Toggle navigation</span>
          &#x2630;
        </button>

        <%= link_to 'Order Food', root_path, class: 'navbar-brand' %>

        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <ul class="nav navbar-nav">
                <li class="nav-item"><a href="/" class="nav-link">Заведения</a>
                </li>
                <li class="nav-item"><%= link_to "Блюда", dishes_path, class: "nav-link" %>
                </li>
            </ul>
            <div class="navbar-nav ml-auto">
              <div class="navbar-nav ml-auto">
                  <% if user_signed_in? %>
                    <div class="nav-item">
    <span class="navbar-text">
      Hello, &nbsp;
    <span>
  </div>

  <div class="dropdown show">
    <%= link_to current_user.name, edit_user_registration_path(current_user), class: 'btn btn-secondary dropdown-toggle', 'role' => "button", 'id' => "dropdownMenuLink", 'data-toggle' => "dropdown", 'aria-haspopup' => "true", 'aria-expanded' => "false" %>
    <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
      <%= link_to 'Edit profile', edit_user_registration_path(current_user), class: 'dropdown-item' %>
      <%= link_to 'Sign out', destroy_user_session_path, method: :delete, class: 'dropdown-item' %>
    </div>
  <div>
                  <% else %>
                      <div class="nav-item">
                         <%= link_to 'Sign up', new_user_registration_path, class: 'nav-link' %>
                      </div>
                      <div class="nav-item">
                         <%= link_to 'Log in', new_user_session_path, class: 'nav-link' %>
                      </div>
                  <% end %>
                </div>
            </div>
        </div>
    </div>
</nav>